Public Member Functions | Static Public Attributes

# EnginePreviewWindow Struct Reference

Inheritance diagram for EnginePreviewWindow:

## Public Member Functions
| EnginePreviewWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Static Public Attributes
static const int | VEHICLE_SPACE = 40

## Detailed Description

Definition at line 61 of file engine_gui.cpp.

## Member Function Documentation

virtual void EnginePreviewWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 83 of file engine_gui.cpp.

References _local_company, DrawString(), DrawStringMultiLine(), DrawVehicleEngine(), EIT_PREVIEW, GetEngineCategoryName(), GetEngineInfoString(), GetEnginePalette(), GetStringHeight(), SA_CENTER, SA_HOR_CENTER, SetDParam(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WID_EP_QUESTION.

virtual void EnginePreviewWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 102 of file engine_gui.cpp.

References CMD_WANT_ENGINE_PREVIEW, DoCommandP(), WID_EP_NO, and WID_EP_YES.

virtual void EnginePreviewWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 114 of file engine_gui.cpp.

References _local_company, and Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_engine_pool >::Get().

virtual void EnginePreviewWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 72 of file engine_gui.cpp.

References FONT_HEIGHT_NORMAL, GetEngineCategoryName(), GetEngineInfoString(), GetStringHeight(), SetDParam(), WD_PAR_VSEP_WIDE, and WID_EP_QUESTION.

The documentation for this struct was generated from the following file:

- src/engine_gui.cpp